#include <bits/stdc++.h>

using namespace std;

#define int long long

vector<vector<int>> tree(200001);
vector<vector<int>> OrTree(2000001);
vector<int> used(2000001, 0);
vector<int> lens(2000001, 0);

void orient(int u, int len)
{
    used[u] = 1;
    len ++;
    for(int i : tree[u]){
        if(used[i] == 1)
            continue;
        OrTree[u].push_back(i);
        lens[i] = len;
        orient(i, len);
    }
}

void dfs(int u, int len)
{
    len ++;
    for(int i : OrTree[u]){
        if(len < lens[i]){
            lens[i] = len;
            dfs(i, len);
        }
    }
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, k, t;
    cin >> n >> k >> t;
    for(int i = 0; i < n-1; i++){
        int a, b;
        cin >> a >> b;
        tree[a].push_back(b);
        tree[b].push_back(a);
    }
    orient(1, 0);
    for(int i = 0; i < k; i ++){
        int a = 1, makc = 0;
        for(int i = 0; i <= n; i ++){
            if(lens[i] > makc){
                makc = lens[i];
                a = i;
            }
        }
        if(makc == 1)
            break;
        OrTree[1].push_back(a);
        lens[a] = 1;
        dfs(a, 1);
    }
    int makc = 0;
    for(int i = 0; i <= n; i ++){
        if(lens[i] > makc){
            makc = lens[i];
        }
    }
    cout << makc;
}
